Subject: [ANCP] Why does ANCP use GSMP?

From: Lloyd Wood <[email-masked]>
Date: Wed, 20 Jun 2007 20:31:29 +0100

How does ANCP work? What is the plumbing, and how are messages communicated?

I understand that ANCP depends on GSMPv3, though you have to dig pretty deep into the protocol specification to discover this fact. (I find it interesting that the framework document skips nicely over the whole GSMP dependency, and that the only reason given in the charter for using GSMP is that early implementations in this space use it.)

Current specification of ANCP seems to be all high-level stuff; how the plumbing actually works is glossed over with a handwave, and there's a long trail of document dependencies. Though ANCP depends on GSMP, it's stated in
http://www.ietf.org/internet-drafts/draft-ietf-ancp-protocol-00.txt
(which, btw, is filled with "smart quotes" _ I see a lot of questionmarks, which is appropriate) that only TCP is used for ANCP. A detailed example of a message exchange or two would be useful to see to grok how the protocol is intended to work.

I don't see how ANCP can both be an extension to an existing protocol, and yet also try to restrict how that existing protocol is used. This is called 'having your cake and eating it'. Given that GSMP was ATM-only before version 3, and that ANCP is only using version 3 and only running IP, while ATM remains the core of GSMP -- why is ANCP using GSMP at all? It seems like an unnatural fit, rather than a logical extension of GSMP. (And overloading TCP's RST/ACK for ANCP's purposes when there's a capability mismatch - seriously? Communicating _how_ there's a mismatch would be more useful. If that's the only way you can communicate this in GSMP, GSMP is obviously the wrong thing to use.)

The framework document discusses ATM a _lot_, which makes ANCP's TCP-only protocol restriction on GSMP more curious. Is GSMP the right choice to base ANCP on? Is TCP even the right choice for small messages, or is it overkill?

If ANCP is leveraging the GSMP framework, ANCP is leveraging everything that GSMP comes with, including over-ATM, over Ethernet, over-TCP. Is that baggage desirable?

(I'm playing devil's advocate here, as requested by Woj in his capacity as wg chair. We have a problem I described previously that we thought ANCP could be adapted to be a solution for - but adapting the entire complexity of GSMP to solve a point problem strikes me as increasingly wrong even for ANCP itself, given how ANCP is using GSMP. So the solution to our problem would be an extension of ANCP, which is an extension of GSMP, but only in some preferred ways?)

Why is GSMP use a good idea for ANCP?

thanks,

L.

<http://www.ee.surrey.ac.uk/Personal/L.Wood/<[email-masked]>

_______________________________________________
ANCP mailing list
[email-masked]
https://www1.ietf.org/mailman/listinfo/ancp